package fr.free.supertos.root.testroot;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.widget.TextView;

public class TestPresenceRootActivity extends Activity {


    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        RunRootCommand exeroot = new RunRootCommand();
        TextView tv = new TextView(this);
        
        if (exeroot.isRoot())
        	tv.setText("Passage en root !");
        else
        	tv.setText("Echec lors du passage en root !");
        
        exeroot.exitRootCommand();
        
        setContentView(tv);
        
    }

    public class RunRootCommand
    {
    	Process suProcess=null;
    	boolean bNoRoot=true; // On pourrait s'en passer
    	DataOutputStream clavier;
//	    	DataInputStream ecran;
    	BufferedReader ecran;
    	
    	// Constructeur qui va crer un processus shell avec les privilges root
    	public RunRootCommand ()
    	{
    		try {
				suProcess = Runtime.getRuntime().exec("su");
				bNoRoot=false;
				clavier = new DataOutputStream(suProcess.getOutputStream());
//					ecran = new DataInputStream(suProcess.getInputStream()); Depreci !
				ecran = new BufferedReader (new InputStreamReader (suProcess.getInputStream()));
			} catch (IOException e) {
				Log.d("RunRootCommand", "Excution de la commande su impossible !");
				e.printStackTrace();
			}
    	}
    	
    	// Terminer notre processus shell
    	public void exitRootCommand ()
    	{
    			sendCommand ("exit");
    	    	suProcess=null;
    	    	bNoRoot=true;
    	    	clavier=null;
    	    	ecran=null;
    	}
    	
    	// Pour envoyer une commande au shell
    	public void sendCommand (String cmd)
    	{
    		if (null != suProcess && null != clavier)
    		{
    			try {
					clavier.writeBytes(cmd+"\n");
					clavier.flush();
				} catch (IOException e) {
					Log.d("sendCommand", "Perte des connexions aux flux des commandes !");
					e.printStackTrace();
				}
                
    		}
    	}
    	
    	// Pour lire les resultats de la commande
		public String readLine ()
    	{
    		String line=null;
    		try {
				line=ecran.readLine();
			} catch (IOException e) {
				Log.d("readLine", "Perte des connexions aux flux des rsultats !");
				e.printStackTrace();
			}
    		return line;
    	}
    	
		// Tester que l'on est bien root !
    	public boolean isRoot()
    	{
    		boolean bIsRoot = false;
        
    		if (false == bNoRoot && null != suProcess && null != clavier && null != ecran)
    		{
    			sendCommand ("id");

    			String currUid = readLine();
	            if (null == currUid)
	            {
	              bIsRoot = false;
	              Log.d("ROOT", "Nous n'avons pas les droits root");
	            }
	            else
	            {
		            if (true == currUid.contains("uid=0"))
		            {
		            	bIsRoot = true;
		            	Log.d("ROOT", "Nous sommes bien root !");
		            }
		            else
		            {
		            	bIsRoot = false;
		              	Log.d("ROOT", "L, nous ne sommes pas root: " + currUid);
		            }
	            }
            }
    		
    		return bIsRoot;
        }
    }

}